package xyz.tbvns.Editor;

import xyz.tbvns.Models.Animation;
import xyz.tbvns.Models.GDModel;
import xyz.tbvns.Models.OBJReader;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.ArrayList;
import java.util.List;

public class ModelsManager {
    public static final List<GDModel> models = new ArrayList<>();
    public static final List<Animation> animations = new ArrayList<>();

    public void addAnimated(File folder) throws FileNotFoundException {
        List<File> OBJs = new ArrayList<>();
        List<File> MTLs = new ArrayList<>();

        for (int i = 0; i < folder.listFiles().length; i++) {
            File f = folder.listFiles()[i];
            if (f.getAbsolutePath().endsWith(".obj")) {
                OBJs.add(f);
            }
        }

        for (int i = 0; i < folder.listFiles().length; i++) {
            File f = folder.listFiles()[i];
            if (f.getAbsolutePath().endsWith(".mtl")) {
                MTLs.add(f);
            }
        }

        Animation animation = new Animation();

        for (int i = 0; i < OBJs.size(); i++) {
            GDModel model = new GDModel(
                    OBJReader.getFaceAnimation(OBJs.get(i), MTLs.get(i))
            );
            animation.getFrames().add(model);
        }
        animations.add(animation);
    }
}
