package xyz.tbvns.GeometryDash;

import com.badlogic.gdx.graphics.Texture;
import com.badlogic.gdx.graphics.VertexAttributes;
import com.badlogic.gdx.graphics.g3d.Model;
import com.badlogic.gdx.graphics.g3d.ModelCache;
import com.badlogic.gdx.graphics.g3d.ModelInstance;
import com.badlogic.gdx.graphics.g3d.utils.ModelBuilder;
import xyz.tbvns.Managers.TexturesManager;
import xyz.tbvns.Objects.Level;
import xyz.tbvns.Objects.Object;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

public class LevelUtils {
    private static List<Model> models = new ArrayList<>();
    private static ModelCache modelCache = new ModelCache();

    public static ModelCache generateModelCache(Level level) throws IOException {
        modelCache.dispose();
        for (Model model : models) {
            model.dispose();
        }
        models.clear();
        modelCache = new ModelCache();
        modelCache.begin();
        for (Object object : Object.fromLevel(level)) {
            try {
                Texture texture = TexturesManager.idTextureMap.get(Integer.parseInt(object.getProperties().get("1")));
                System.out.println(object.getProperties());
                float factor = 120f;
                Model model = new ModelBuilder().createRect(
                        0f, 0f, 0f,
                        texture.getWidth() / factor, 0f, 0f,
                        texture.getWidth() / factor, texture.getHeight() / factor, 0f,
                        0f, texture.getHeight() / factor, 0f,
                        0f, 0f, 0f,
                        TexturesManager.idMaterialMap.get(Integer.parseInt(object.getProperties().get("1"))),
                        VertexAttributes.Usage.Position | VertexAttributes.Usage.TextureCoordinates
                );
                models.add(model);
                modelCache.add(new ModelInstance(model, Float.parseFloat(object.getProperties().get("2")) / 30, Float.parseFloat(object.getProperties().get("3")) / 30, 0));
            } catch (Exception e){};
        }
        modelCache.end();
        return modelCache;
    }
}
